'use strict';

exports.__esModule = true;
exports.createCallbackReducer = createCallbackReducer;
exports.generateReducers = generateReducers;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _redux = require('redux');

var _action = require('./action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function createCallbackReducer(initReducerName) {
    var initialState = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    if (!initReducerName) {
        throw new SyntaxError('Improperly configured. initReducerName must be defined.');
    }

    return function () {
        var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
        var _ref = arguments[1];
        var type = _ref.type;
        var reducerName = _ref.reducerName;
        var callback = _ref.callback;
        var kwargs = _ref.kwargs;

        if (type.endsWith(_action.CALLBACK_ACTION_SUFFIX) && reducerName === initReducerName) {
            return callback.apply(undefined, kwargs.concat([state]));
        }
        return state;
    };
}

function generateReducers(path, obj) {
    if (!_lodash2["default"].isPlainObject(obj)) {
        throw new SyntaxError('Only plain object must be here.');
    }

    return (0, _redux.combineReducers)(_lodash2["default"].mapValues(obj, function (value, key) {
        if (_lodash2["default"].isPlainObject(value) && _lodash2["default"].keys(value).length) {
            return generateReducers(`${ path }.${ key }`, value);
        }

        return createCallbackReducer(`${ path }.${ key }`, value);
    }));
}