'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.createDecorator = createDecorator;
exports.createWrapper = createWrapper;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _action = require('./action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function createDecorator(store) {
    return function (reducerName, callbackName) {
        return function (target, property, descriptor) {
            return _extends({}, descriptor, {
                value: createWrapper(store)(reducerName, descriptor.value, callbackName)
            });
        };
    };
}

function createWrapper(store) {
    return function (reducerName, callback, callbackName) {
        if (typeof callback !== 'function') {
            throw new SyntaxError('Only functions can be reducer');
        }

        var type = getCallbackType(callbackName || callback.name);

        return function () {
            for (var _len = arguments.length, kwargs = Array(_len), _key = 0; _key < _len; _key++) {
                kwargs[_key] = arguments[_key];
            }

            var action = {
                type,
                callback,
                reducerName,
                kwargs
            };

            return store.dispatch(action);
        };
    };
}

function getCallbackType(callbackName) {
    return callbackName ? `${ _lodash2["default"].toUpper(_lodash2["default"].snakeCase(callbackName)) }_${ _action.CALLBACK_ACTION_SUFFIX }` : `ANONYMOUS_${ _action.CALLBACK_ACTION_SUFFIX }`;
}